package com.jersey.series.queryparam;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

@Path("bookservice")
public class BookServiceImpl implements IBookService {

	// http://localhost:8080/Jersey-QueryParam/rest/bookservice/book?name=Neuroscience
	@GET
	@Path("book")
	@Consumes({MediaType.TEXT_PLAIN})
	@Produces({MediaType.TEXT_PLAIN})
	public Response printBookName(@QueryParam("name") String bookName) {

		String bookDetail = "Book name is " + bookName;
		return Response.status(200).entity(bookDetail).build();
	}

	// http://localhost:8080/Jersey-QueryParam/rest/bookservice/bookdetail?name=Medical-Microbiology&author=Brooks&category=Microbiology
	@GET
	@Path("bookdetail")
	@Consumes({MediaType.TEXT_PLAIN})
	@Produces({MediaType.TEXT_PLAIN})
	public Response printCompleteBookDetails(
			@QueryParam("name") String bookName, 
			@QueryParam("author") String author, 
			@QueryParam("category") String category) {

		String bookCompleteDetail = "Book complete detail [Name=" + bookName +  ", Author=" + author + ", Category=" + category + "]";
		return Response.status(200).entity(bookCompleteDetail).build();
	}
}